/*
 
Copyright (C) NEC Corporation 2012-2013. All Rights Reserved. 
Copyright (C) NEC Soft, Ltd. 2012-2013. All Rights Reserved. 
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
*/


/*******************************************************************************
 * Create (job management) JOB_DETAIL
 */
var fn = function(_view){
	var __ = cm
	,_pers = this
	;
	
	var view = $.extend({}, __._fnview_grid, {
		session_id: ""
		,manager_ip:""
		,load_flg    : false

		,/*
		 * Set caption of grid
		 */
		setCaption: function(){
			var _ = this;
			
			if (_.manager_ip && _.manager_ip != "") {
				_.grid.setCaption([
					__.getLang("session_id"), ": ", _.session_id
					,",&nbsp;"
	                ,__.getLang("manager"), ": " , _.manager_ip
				].join(""));
			} else {
				_.grid.setCaption([
					__.getLang("session_id"), ": ", _.session_id
				].join(""));
			}
		}
		
		,/*
		 * Update node detail
		 */
		updateNodeDetail: function(session_id, job_id, jobunit_id, manager_ip){
			var vw_dtl;
			
			// Check whether view "node detail" exists
			if(!(vw_dtl = _pers["node_detail"])){
				return;
			}
			
			// Update data for view
			vw_dtl.updateData({
				session_id: session_id,
				job_id: job_id,
				jobunit_id: jobunit_id,
				manager_ip: manager_ip
			});
		}
		
		,/*
		 * Update forward file
		 */
		updateForwardFile: function(session_id, job_id, jobunit_id, manager_ip){
			var vw_dtl;
			
			// Check whether view "forward file" exists
			if(!(vw_dtl = _pers["forward_file"])){
				return;
			}
			
			// Update data for view
			vw_dtl.updateData({
				session_id: session_id,
				job_id: job_id,
				jobunit_id: jobunit_id,
				manager_ip: manager_ip
			});
		}
		
		,/*
		 * Update data when click on view 'history' content
		 */
		updateData: function(){
			var _ = this;

			// call reloadGrid function 
			if (!(_.load_flg)) {
				_.load_flg = true;
				_.reloadGrid();
			}
		}
		
		, /*
		 * reload data when click on view 'history' content
		 */
		reloadGrid: function(){
			var _       = this 
			,session_id = _view.__session_id
			,manager_ip = _view.__manager_ip
			,grid       = _.grid
			;
			// Case updating
			_.session_id = session_id;
			_.manager_ip = manager_ip;
			
			// Set caption
			_.setCaption();
			
			// Clear selection
			grid.resetSelection();
			// Check to clear?
			if(session_id === ""){
				grid.clearGridData();
				
				// Disable button "start" and "stop"
				_.$btns.children("#start").attr("disabled", true);
				_.$btns.children("#start").addClass("ui-state-default");
				_.$btns.children("#stop").attr("disabled", true);
				_.$btns.children("#stop").addClass("ui-state-default");
				
				// Clear data of views which belong this view
				_.updateNodeDetail("", "", "", "");
				_.updateForwardFile("", "", "", "");
                _.load_flg = false;
				return;
			}
			$("#load_grid_jobmanagement_job_detail").show();
			// Reload grid
			grid.refreshData({
				sessionId: session_id,
				managerIpForSearch: manager_ip
			});
		}
		
		,/*
		 * Get scope list
		 */
		createGrid: function(){
			var _ = this;
			
			$.ajax({
				url      : "get_job_detail_table_define"
				,cache   : false
				,dataType: "json"
				,type    : "get"
				,success : function(data_respond){
					var grid   = _.grid
					,post_data = {}
					,$mn       = grid.siblings("#menu_rightclick").children("ul:first")
					;
					
					// Check validation of data_respond
					if (__.checkJsonError(data_respond) !== true){
						return;
					}
					
					// Check session_id of view: control
					if (_view.__session_id) {
						_.session_id = _view.__session_id;
						
						post_data.sessionId = _.session_id;
					}
					if (_view.__manager_ip) {
						_.manager_ip = _view.__manager_ip;
						
						post_data.managerIpForSearch = _.manager_ip;
					}
					// Set some options for grid
					$.extend(data_respond, {
						caption         : "&nbsp;"
						,url            : "get_job_detail"
						,treeGrid       : true
						,treeGridModel  : "adjacency"
						,ExpandColumn   : "tree"
						,treeIcons      : {
							plus  :"ui-icon-hnm-plus"
							,minus:"ui-icon-hnm-minus"
							,leaf :"ui-icon-hnm-none"
						} 
						,postData       : post_data
						,ajaxGridOptions: {
							// This function prevent grid send request without 
							//   sessionId or sessionId = "" 
							beforeSend: function (jqXhr, settings){
								var str_params = settings.data // form: a=b&c=d ...
								,params = str_params.split("&")
								,count  = params.length
								;
								
								// Check every parameter (form: a=b) 
								while(count--){
									var str_param = params[count]
									,param = str_param.split("=")
									;
									
									// Check parameter:
									if(param[0] && (param[0] == "sessionId") && (param[1])){
										return true;
									}
								}
								
								return false;
							}
						}
						,loadComplete   : function(){
							var session_id = _view.__session_id;

							var curent_session_id = _pers["node_detail"].__session_id;
							var curent_jobunit_id = _pers["node_detail"].__jobunit_id;
							var curent_job_id     = _pers["node_detail"].__job_id;

							if (curent_jobunit_id !== undefined && curent_jobunit_id.length > 0
								&& curent_session_id !== undefined && curent_session_id.length > 0
								&& curent_job_id !== undefined && curent_job_id.length > 0) {
                            
								var in_job_detail = $(grid).find('tr').filter(function(){
									return ($(this).find('td:nth-child(5)').first().text() == curent_job_id && 
											$(this).find('td:nth-child(7)').first().text() == curent_jobunit_id);
								});
								
								_.updateNodeDetail("", "", "", "");
								_.updateForwardFile("", "", "", "");
								
								if (curent_session_id == _.session_id && in_job_detail.length > 0) {
									var row_id = $(in_job_detail[0]).attr('id');
									grid.jqGrid('setSelection',row_id);
								}
							}
							
							if (!grid.getGridParam("selrow")) {
								// Disable button "start" and "stop"
								if(grid.getGridParam("selarrrow").length != 1) {
									_.$btns.children("#start").attr("disabled", true);
									_.$btns.children("#start").addClass("ui-state-default");
									_.$btns.children("#stop").attr("disabled", true);
									_.$btns.children("#stop").addClass("ui-state-default");
								}
							}
							
							if(session_id === _.session_id){
								_.load_flg = false;
							}else{
								setTimeout(function(){
									_.reloadGrid();
								}, 1);
							}
						}
						,onSelectRow    : function(row_id){
							var i     = this
							,row_data = $(i).getRowData(row_id)
							,session_id = _.session_id
							,job_id     = $.jgrid.htmlEncode(row_data.jobId)
							,jobunit_id = $.jgrid.htmlEncode(row_data.jobunitId)
							,manager_ip = _.manager_ip;
							;
							
							// Enable button "start" and "stop"
							_.$btns.children("#start").attr("disabled", false);
							_.$btns.children("#start").removeClass("ui-state-default");
							_.$btns.children("#stop").attr("disabled", false);
							_.$btns.children("#stop").removeClass("ui-state-default");
							
							_.updateNodeDetail(session_id, job_id, jobunit_id, manager_ip);
							_.updateForwardFile(session_id, job_id, jobunit_id, manager_ip);
						}
					});
					
					grid.processData(data_respond);
					grid.controlSize();
					_.setCaption();
					
					// Bind context menu for grid(right click)
					grid.contextMenu(
						"menu_rightclick"
						,{
							onContextMenu: function(event, menu){
								var row_id = $(event.target).closest("tr").attr("id")
								,selrow    = grid.getGridParam("selrow")
								;
								
								if (!selrow || (selrow != row_id)) {
									// After this action happen, it will call onSelectRow
									grid.jqGrid("setSelection", row_id, true);
									grid.init_list_row_id = row_id;
								}
								
								if(!grid.getGridParam("selrow")) {
									// Disable menu "start" and "stop"
									$mn.children("#start").attr("disabled", true);
									$mn.children("#start").addClass("ui-state-disabled");
									$mn.children("#start").addClass("ui-state-default");
									$mn.children("#stop").attr("disabled", true);
									$mn.children("#stop").addClass("ui-state-disabled");
									$mn.children("#stop").addClass("ui-state-default");
								} else {
									// Enable menu "start" and "stop"
									$mn.children("#start").attr("disabled", false);
									$mn.children("#start").removeClass("ui-state-disabled");
									$mn.children("#start").removeClass("ui-state-default");
									$mn.children("#stop").attr("disabled", false);
									$mn.children("#stop").removeClass("ui-state-disabled");
									$mn.children("#stop").removeClass("ui-state-default");
								}
								return true;
							}
							,container   : grid.$ctn
							,bindings    : {
								start    : function(){
									_.startJob();
								}
								,stop    : function(){
									_.stopJob();
								}
							}
						}
					);
				}
				,error   : __.loadDataError
			});
		}
		
		,/*
		 * Create dialogs
		 */
		createDialog: function(){
			// Cache local variant
			var _ = this;
			
			// Declare operation job dialog
			__.createOperationDialog.call(
				_
				,"operationjob"
				,{
					option: {
						title   : ""
						,width  : 450
						,height : 300
						,open   : function(){
							$(this).siblings('div.ui-dialog-buttonpane:first').find("button:eq(0)").focus();
						}
						,buttons: [
							{
								text  : __.getLang("ok_o")
								,click: function(){
									var retData = _.operationjob.checkInputs();
									
									switch (retData.result) {
										case 0:
											_.operationjob.execute();
											$(this).dialog("close");
											break;
										case 1:
											$(this).dialog("close");
											__.openPromptDlg({
												message: {content:retData.message
														  ,title :retData.title}
												,level : retData.level
												,title : retData.title
											}, false);
											break;
										case 2:
											__.openPromptDlg({
												message: {content:retData.message
														  ,title :retData.title}
												,level : retData.level
												,title : retData.title
											}, false);
											break;
										default:
											_.operationjob.execute();
											$(this).dialog("close");
											break;
									}
								}
							}
							,{
								text  : __.getLang("cancel")
								,click: function(){
									$(this).dialog("close");
								}
							}
						]
					}
					,url  : "get_operation_job_property"
				}
			);
		}
		
		,/*
		 * Bind some action
		 */
		bindAction: function(){
			var _  = this
			,_btns = _.$btns
			;
			
			// Bind update grid data
			_btns.children("#start").click(function(){
				_.startJob();
			});
			
			// Bind update grid data
			_btns.children("#stop").click(function(){
				_.stopJob();
			});
		}
		
		,/*
		 * Start job
		 */
		startJob: function(){
			var _   = this
			,grid   = _.grid
			,row_id = grid.getGridParam("selrow")
			;
			if(row_id == null || row_id <= 0){
				row_id = grid.onclick_row_id;
			}	
			if(row_id){
				var operationjob = _.operationjob
				,row_data  = grid.getRowData(row_id)
				;
				
				// Set post data
				operationjob.setPostData({
					control     : "start"
					,sessionId  : _view.__session_id
					,jobunitId  : $.jgrid.htmlEncode(row_data.jobunitId)
					,jobId      : $.jgrid.htmlEncode(row_data.jobId)
					,managerIpForSearch:_.manager_ip
				});
				
				// Set dialog title
				operationjob.setTitleText(__.getLang("job") + "[" + __.getLang("start") + "]");
				
				// Open dialog
				operationjob.open();
			}
		}
		
		,/*
		 * Stop job
		 */
		stopJob: function(){
			var _   = this
			,grid   = _.grid
			,row_id = grid.getGridParam("selrow")
			;
			if(row_id == null || row_id <= 0){
				row_id = grid.onclick_row_id;
			}	
			if(row_id){
				var operationjob = _.operationjob
				,row_data  = grid.getRowData(row_id)
				;
				
				// Set post data
				operationjob.setPostData({
					control     : "stop"
					,sessionId  : _view.__session_id
					,jobunitId  : $.jgrid.htmlEncode(row_data.jobunitId)
					,jobId      : $.jgrid.htmlEncode(row_data.jobId)
					,managerIpForSearch:_.manager_ip
				});
				
				// Set dialog title
				operationjob.setTitleText(__.getLang("job") + "[" + __.getLang("stop") + "]");
				
				// Open dialog
				operationjob.open();
			}
		}
	});
	
	return view;
};