/*
 
Copyright (C) NEC Corporation 2012. All Rights Reserved. 
Copyright (C) NEC Soft, Ltd. 2012. All Rights Reserved. 
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
*/

package com.necsoft.hinemos.webclient.listener;

import javax.servlet.http.*;

import com.necsoft.hinemos.webclient.accesscontrol.util.LoginSessionManager;

/**
 * セッションタイムアウト後Hinemosマネージャからログアウトするクラス
 * 
 * @version 1.0.0
 * @since 1.0.0
 **/
public class SessionLifeCycleEventListener implements HttpSessionListener {

    public void sessionCreated(HttpSessionEvent se) {
        // 無し
    }

    /*
     * @see
     * javax.servlet.http.HttpSessionListener#sessionDestroyed(javax.servlet
     * .http.HttpSessionEvent) Hinemosマネージャからログアウトする
     */
    public void sessionDestroyed(HttpSessionEvent se) {
        HttpSession session = se.getSession();
        LoginSessionManager.processLogout(session);
    }
}